import controlP5.*; //<>// //<>//
import peasy.*;
import peasy.org.apache.commons.math.*;
import peasy.org.apache.commons.math.geometry.*;

PeasyCam cam;

PImage bgImg;

PShader pointShader;
float weight = 40; 

float[][] angVs = new float[100][2]; 
float[][][] angs = new float[21][100][2]; 
float v_range = 0.01;
float[] activities = new float[21];
int[] workCount = new int[21];
float currentAct = 1;
int showIndex = 0;
float drawPosition = 0;

float targetR  = 15;
float baseR = 2;
float targetDrawPosition  = 15;
float GlobalMaxR = 300;
float maxR[] = new float[21]; 
float blingblingFreq[] = new float[21]; 
float phase[][] = new float[21][100];
float r  = 15;
float ang1 = 0;
float ang2 = 0;
float sphereSaperation = 1.5f*GlobalMaxR;
int textSize = 20;
float pointSize = 120;
boolean ifDrawColor = false;
boolean ifDrawAllColor = true;
float cameraMinDistance = 100f;

PFont lato;

String[] vertSource = new String[] {
  "#define PROCESSING_POINT_SHADER", 
  "uniform mat4 projection;", 
  "uniform mat4 modelview;", 
  "uniform float weight;", 
  "attribute vec4 vertex;", 
  "attribute vec4 color;", 
  "attribute vec2 offset;", 
  "varying vec4 vertColor;", 
  "varying vec2 texCoord;", 
  "void main() {", 
  "vec4 pos = modelview * vertex;", 
  "vec4 clip = projection * pos;", 
  "gl_Position = clip + projection * vec4(offset, 0, 0);", 
  "texCoord = (vec2(0.5) + offset / weight);", 
  "vertColor = color;", 
  "}"
};
String[] fragSource = new String[] {
  "#ifdef GL_ES", 
  "precision mediump float;", 
  "precision mediump int;", 
  "#endif", 
  "uniform sampler2D sprite;", 
  "varying vec4 vertColor;", 
  "varying vec2 texCoord;", 
  "void main() {", 
  "gl_FragColor = texture2D(sprite, texCoord) * vertColor;", 
  "}"
};

void setup() {    
  bgImg = loadImage("background3.jpg");
  println(bgImg.width);
  println(bgImg.height);

  //size(500, 500, P3D); 
  fullScreen(P3D); 
  cam = new PeasyCam(this, GlobalMaxR);
  cam.setMinimumDistance(cameraMinDistance);

  for (int i = 0; i<activities.length; i++) {
    workCount[i] = data_film[i]+data_televisionFilm[i]+data_televisionSeries[i]+data_videoGames[i];
    workCount[i]*=10;
    currentAct = workCount[i]/100f;
    activities[i] = currentAct;
    blingblingFreq[i] = currentAct*0.5f;
    maxR[i] = GlobalMaxR*currentAct;

    for (int j = 0; j<workCount[i]; j++) {
      angs[i][j] = new float[]{random(0, maxR[i])+baseR, random(-PI, PI)};
      phase[i][j] = random(0, 2*PI);
    }
  }

  for (int i = 0; i<workCount.length; i++) {
    println("workCount["+(i+1997)+"] = "+workCount[i]);
  }




  targetDrawPosition = showIndex;
  currentAct = activities[showIndex];
  //targetR = maxR[i]*currentAct;

  textMode(MODEL);

  pointShader = new PShader(this, vertSource, fragSource);
  pointShader.set("weight", weight);
  pointShader.set("sprite", loadImage("texture.gif"));

  strokeWeight(weight);
  strokeCap(SQUARE);
  
  lato = createFont("Lato-Light.ttf",32);
  textFont(lato);
}

void draw() {
  //---background
  background(20+(int)((120-20)*(cameraMinDistance/cam.getDistance())));  // clears backgound every frame
  //background(50);
  //hint(DISABLE_DEPTH_MASK);
  //cam.beginHUD();
  //image(bgImg, 0, 0, width, height);
  //cam.endHUD();
  //hint(ENABLE_DEPTH_MASK); 


  cam.setRotations(0, 0, 0);

  //lato font

  shader(pointShader, POINTS);
  blendMode(ADD);
  hint(DISABLE_DEPTH_TEST);



  for (int drawIndex = 0; drawIndex<activities.length; drawIndex++ ) {
    drawPosition = drawIndex*sphereSaperation;
    currentAct = workCount[drawIndex]/100f;
    //r = maxR*currentAct+baseR;
    pushMatrix();
    translate(drawPosition, 0, 0);

    ifDrawColor = true;
    strokeWeight(pointSize);
    text(""+(drawIndex+1997), 0, 5*textSize, 0);

    //sphere(baseR);
    int drawCount = 0;
    for (int i = 0; i<workCount[drawIndex]; i++) {

      if (ifDrawColor) {
        //println("drawCount = "+drawCount+"");
        if (drawCount>=0&&drawCount<10*data_film[drawIndex]) {
          stroke(c1, map(angs[drawIndex][i][0], baseR+maxR[drawIndex], 0, 0, 255));
        } else if (drawCount>=10*data_film[drawIndex]&&drawCount<10*data_film[drawIndex]+10*data_televisionFilm[drawIndex]) {
          stroke(c2, map(angs[drawIndex][i][0], baseR+maxR[drawIndex], 0, 0, 255));
        } else if (drawCount>=10*data_film[drawIndex]+10*data_televisionFilm[drawIndex]&&drawCount<10*data_film[drawIndex]+10*data_televisionFilm[drawIndex]+10*data_televisionSeries[drawIndex]) {
          stroke(c3, map(angs[drawIndex][i][0], baseR+maxR[drawIndex], 0, 0, 255));
        } else {
          stroke(c4, map(angs[drawIndex][i][0], baseR+maxR[drawIndex], 0, 0, 255));
        }
      }
      //println("workCount["+drawIndex+"] = "+workCount[drawIndex]+"");
      if (drawCount==workCount[drawIndex]) 
        break;
      r = angs[drawIndex][i][0];
      point(r*cos(angs[drawIndex][i][1]), r*sin(angs[drawIndex][i][1]), 0);
      angVs[i][0]=1.5*currentAct;//+random(-0.7, 0.7);
      angVs[i][1]=random(-0.001, 0.001);//+0.1*currentAct;
      if (angs[drawIndex][i][0]<baseR+maxR[drawIndex]) {
        angs[drawIndex][i][0]+=angVs[i][0];
      } else {
        angs[drawIndex][i][0] = baseR;
      }

      angs[drawIndex][i][1]+=angVs[i][1];
      drawCount++;
    }
    popMatrix();
  }

  gui();
}

void keyPressed() {
  if (key == 'd') {
    if (showIndex<workCount.length-1)
      showIndex+=1;
    else
      showIndex = 0;
    targetDrawPosition = showIndex*sphereSaperation;
    cam.lookAt(targetDrawPosition, 0, 0, 2000);
  } else if (key == 'a') {
    if (showIndex>0)
      showIndex-=1;
    else
      showIndex = workCount.length-1;
    targetDrawPosition = showIndex*sphereSaperation;
    cam.lookAt(targetDrawPosition, 0, 0, 2000);
  } else if (key=='s') {
    ifDrawAllColor = !ifDrawAllColor;
  }
}

void gui() {
  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();
  int currenteight = 0;
  int heightInterval = 40;
  textSize(20);
  //text("FPS: "+frameRate, 10, currenteight);
  currenteight+=heightInterval;

  //strokeWeight(heightInterval/2);
  strokeWeight(weight*2);

  stroke(c1);
  point(15, currenteight-heightInterval/3);
  text(" - Film", 25, currenteight);
  currenteight+=heightInterval;

  stroke(c2);
  point(15, currenteight-heightInterval/3);
  text(" - Television Film", 25, currenteight);
  currenteight+=heightInterval;

  stroke(c3);
  point(15, currenteight-heightInterval/3);
  text(" - Television Series", 25, currenteight);
  currenteight+=heightInterval;

  stroke(c4);
  point(15, currenteight-heightInterval/3);
  text(" - Game", 25, currenteight);
  currenteight+=heightInterval;

  cam.endHUD();
  hint(ENABLE_DEPTH_TEST);
}

float getDistance(float[] p1, float[] p2) {
  return (float)Math.sqrt((p1[0]-p2[0])*(p1[0]-p2[0])+(p1[1]-p2[1])*(p1[1]-p2[1])+(p1[2]-p2[2])*(p1[2]-p2[2]));
}